Bug 1843849 (CVE-2020-10758) - CVE-2020-10758 keycloak: DoS by sending multiple simultaneous requests with a Content-Length header value greater than actual byte count of request body
Summary: CVE-2020-10758 keycloak: DoS by sending multiple simultaneous requests with a...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2020-10758
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: 1843833
TreeView+ depends on / blocked
 
Reported: 2020-06-04 10:01 UTC by Paramvir jindal
Modified: 2020-09-15 06:06 UTC (History)
38 users (show)

Fixed In Version: keycloak 11.0.1
Doc Type: If docs needed, set a value
Doc Text:
A flaw was found in Keycloak. This flaw allows an attacker to perform a denial of service attack by sending multiple simultaneous requests with a Content-Length header value greater than the actual byte count of the request body. The highest threat from this vulnerability is to system availability.
Clone Of:
Environment:
Last Closed: 2020-08-18 21:15:28 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:3495 None None None 2020-08-18 16:23:24 UTC
Red Hat Product Errata RHSA-2020:3496 None None None 2020-08-18 16:24:01 UTC
Red Hat Product Errata RHSA-2020:3497 None None None 2020-08-18 16:24:33 UTC
Red Hat Product Errata RHSA-2020:3501 None None None 2020-08-18 16:35:54 UTC
Red Hat Product Errata RHSA-2020:3539 None None None 2020-09-02 09:48:01 UTC

Description Paramvir jindal 2020-06-04 10:01:08 UTC
DoS attack is possible by sending twenty requests simultaneously to the specified keycloak server, all with a Content-Length header value that exceeds the actual byte count of the request body.

https://issues.redhat.com/browse/KEYCLOAK-14363

Comment 6 Paramvir jindal 2020-06-05 05:48:53 UTC
Acknowledgments:

Name: Matt Hamilton (Soluble.ai)

Comment 7 RaTasha Tillery-Smith 2020-06-30 14:17:41 UTC
Mitigation:

- The possibility of this issue largely depends on the environment, specifically the load balancer or reverse proxies between the client and the server. The issue occurs when there is no load balancer in place.

- Proper tuning of HTTP request timeout and keycloak database max pool size can mitigate this issue :
bin/jboss-cli.sh --connect --commands='/subsystem=transactions:write-attribute(name=default-timeout,value=30),/subsystem=undertow/server=default-server/http-listener=default/:write-attribute(name=read-timeout,value=30000),/subsystem=undertow/server=default-server/https-listener=https/:write-attribute(name=read-timeout,value=30000),/subsystem=datasources/data-source=KeycloakDS/:write-attribute(name=max-pool-size,value=100),reload'

Comment 12 errata-xmlrpc 2020-08-18 16:23:21 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.4 for RHEL 6

Via RHSA-2020:3495 https://access.redhat.com/errata/RHSA-2020:3495

Comment 13 errata-xmlrpc 2020-08-18 16:23:57 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.4 for RHEL 7

Via RHSA-2020:3496 https://access.redhat.com/errata/RHSA-2020:3496

Comment 14 errata-xmlrpc 2020-08-18 16:24:31 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.4 for RHEL 8

Via RHSA-2020:3497 https://access.redhat.com/errata/RHSA-2020:3497

Comment 15 errata-xmlrpc 2020-08-18 16:35:51 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On 7.4.2

Via RHSA-2020:3501 https://access.redhat.com/errata/RHSA-2020:3501

Comment 16 Product Security DevOps Team 2020-08-18 21:15:28 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2020-10758

Comment 17 errata-xmlrpc 2020-09-02 09:47:57 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes

Via RHSA-2020:3539 https://access.redhat.com/errata/RHSA-2020:3539


Note You need to log in before you can comment on or make changes to this bug.